
%you first need to run velocity matrices.m


z1;

syms q1d q2d q3d q4d q5d q6d real

q=[q1;q2;q3;q4;q5;q6];
qd=[q1d;q2d;q3d;q4d;q5d;q6d];

dz1=jacobian(z1,q)*qd;
dz2=jacobian(z2,q)*qd;
dz3=jacobian(z3,q)*qd;
dz4=jacobian(z4,q)*qd;
dz5=jacobian(z5,q)*qd;


t1=dz1-cross((Jw1*qd),z1)
t2=dz2-cross((Jw2*qd),z2)
t3=dz3-cross((Jw3*qd),z3)
t4=dz4-cross((Jw4*qd),z4)
t5=dz5-cross((Jw5*qd),z5)

S=@(x)([0 -x(3) x(2);x(3) 0 -x(1);-x(2) x(1) 0]);


%Jv2=[cross(z0,(p2-o0)) cross(z1,(p2-o1)) zeros(3,4)]

%cross(z0,(p2-o0))


temp1=cross(z0,(p2-o0));
temp2=cross(z1,(p2-o1));

d_temp1=jacobian(temp1,q)*qd;
d_temp2=jacobian(temp2,q)*qd;

J_o0=jacobian(o0,q)
J_o1=jacobian(o1,q)

test1=cross(z0,(Jv2-J_o0-Jw1)*qd)
test2=cross(cross(Jw1*qd,z1),p2-o1)+cross(z1,(Jv2-J_o1)*qd)



%Jv3=[cross(z0,(p3-o0)) cross(z1,(p3-o1)) cross(z2,(p3-o2)) zeros(3,3)]

[cross(z0,(o2-o0)) cross(z1,(o2-o1));Jw2]
%cross(z0,(p2-o0))



J_o0=simple(jacobian(o0,q));
J_o1=simple(jacobian(o1,q));
J_o2=simple(jacobian(o2,q));

test1=cross(cross(Jw1*qd,z0),p3-o0)+cross(z0,(Jv3-J_o0)*qd)
test2=cross(cross(Jw2*qd,z1),p3-o1)+cross(z1,(Jv3-J_o1)*qd)
test3=cross(cross(Jw3*qd,z2),p3-o2)+cross(z2,(Jv3-J_o2)*qd)


test1=z0*((p3-o0)'*(Jw1*qd))-Jw1*qd*((p3-o0)'*z0)+cross(z0,(Jv3-J_o0)*qd)
test2=z1*((p3-o1)'*(Jw2*qd))-Jw2*qd*((p3-o1)'*z1)+cross(z1,(Jv3-J_o1)*qd)
test3=z2*((p3-o2)'*(Jw3*qd))-Jw3*qd*((p3-o2)'*z2)+cross(z2,(Jv3-J_o2)*qd)

test1=S(Jw1*qd)*R0b*[0;0;1]+cross(z0,(Jv3-J_o0)*qd)
test2=S(Jw2*qd)*R1b*[0;0;1]+cross(z1,(Jv3-J_o1)*qd)
test3=S(Jw3*qd)*R2b*[0;0;1]+cross(z2,(Jv3-J_o2)*qd)


simplify(dz1-S(Jw1*qd)*R1b*[0;0;1])
simplify(dz2-S(Jw2*qd)*R2b*[0;0;1])
simplify(dz3-S(Jw3*qd)*R3b*[0;0;1])
simplify(dz4-S(Jw4*qd)*R4b*[0;0;1])
simplify(dz5-S(Jw5*qd)*R5b*[0;0;1])




%%


temp1=cross(z0,(o4-o0));
temp2=cross(z1,(o4-o1));
temp3=cross(z2,(o4-o2));

d_t1=jacobian(temp1,q)*qd;
d_t2=jacobian(temp2,q)*qd;
d_t3=jacobian(temp3,q)*qd;


dz0=zeros(3,1);
dz1=S(Jw1*qd)*z1;
dz2=S(Jw2*qd)*z2;
dz3=S(Jw3*qd)*z3;
dz4=S(Jw4*qd)*z3;

Jo0=simple(jacobian(o0,q));
Jo1=simple(jacobian(o1,q));
Jo2=simple(jacobian(o2,q));
Jo3=simple(jacobian(o3,q));
Jo4=simple(jacobian(o4,q));

dJw4=[dz0 dz1 dz2 dz3 zeros(3,2)];

% z0 x (o4 -o0)
%the columns of Jv_4

col1=cross(dz0,o4-o0)+cross(z0,(Jo4-Jo0)*qd)
col2=cross(dz1,o4-o1)+cross(z1,(Jo4-Jo1)*qd)
col3=cross(dz2,o4-o2)+cross(z2,(Jo4-Jo2)*qd)



syms ax ay az real
syms bx by bz real
syms cx cy cz real

a=[ax ay az]';
b=[bx by bz]';
c=[cx cy cz]';








































