clc
clear all
close all

record=0;
scrsz = get(0,'ScreenSize');
set(0,'DefaultFigurePosition', scrsz);

if record==1
aviobj = avifile('different_forces.avi','compression','Cinepak','quality',100);
end

do_ode45=0; 
%a script that draws the robot given angles

global m1 m2 m3 m4 m5 m6 Ut Globn w_ball
global I1xx I1yy I1zz 
global I1xy I1xz I1yz 
global I2xx I2yy I2zz 
global I2xy I2xz I2yz 
global I3xx I3yy I3zz 
global I3xy I3xz I3yz  
global I4xx I4yy I4zz 
global I5xx I5yy I5zz 
global I6xx I6yy I6zz 
global a1 a2 a3 d1 d4 d6 
global r1 r2 r3 r4 r5 r6 g
global Kp Kd q_last radref S w1 w2 w3 w4 w5 w6 U_save START
global turn_on_speed Kd6 Kp6 global_time sat pc r_sphere SAVE_B SAVE_Bd

turn_on_speed=1;
w_ball=6;

sat=@(x)((1/2*sign(x)+1/2)*x-(1/2*sign(x-1)+1/2)*(x-1));
Rx=@(th)([1 0 0; 0 cos(th) -sin(th); 0 sin(th) cos(th)]);
Ry=@(th)([cos(th) 0 sin(th);0 1 0;-sin(th) 0 cos(th)]);
Rz=@(th)([cos(th) -sin(th) 0;sin(th) cos(th) 0;0 0 1]);
S=@(x)([0 -x(3) x(2);x(3) 0 -x(1);-x(2) x(1) 0]);

fig=figure;

ref_pos=[];
leader_pos=[];
follower_pos=[];
ref_ori=[];
leader_ori=[];
follower_ori=[];
pos_error=[];
ori_error=[];
shortest_distance=[];
input=[];


radref=0.7;

Kp=2500*eye(3);%+500*ones(3);
Kd=500*eye(3);%+20*ones(3);

Kp6=1300*eye(6)+700*ones(6);
Kd6=550*eye(6)+150*ones(6);
    
q1=rand*2*pi;
q2=rand*2*pi;
q3=rand*2*pi;
q4=rand*2*pi;
q5=rand*2*pi;
q6=rand*2*pi;

w1=0.7;
w2=rand*.5;
w3=rand*.5;
w4=rand*.1;
w5=rand*.1;
w6=rand*.1;


w1 =0.7000;
w2 =0.0604;
w3 =0.4314;
w4 =0.0484;
w5 =0.0845;
w6 =0.0209;


% w1=1;
% w2=0.01+pi/2;
% w3=0.01;
% w4=-.02+pi/2;
% w5=0.01;
% w6=0.01+pi/2;

g=9.81;

m1=10;
m2=10;
m3=10;
m4=1;
m5=1;
m6=1;

I1xx=0.1;
I1yy=0.1;
I1zz=0.1;

I1xy=-.1;
I1xz=-.1;
I1yz=-.1;

I2xx=0.1;
I2yy=0.1;
I2zz=0.1;

I2xy=-.1;
I2xz=-.1;
I2yz=-.1;

I3xx=0.1;
I3yy=0.1;
I3zz=0.1;

I3xy=-.1;
I3xz=-.1;
I3yz=-.1;

I4xx=0.001;
I4yy=0.001;
I4zz=0.001;

I5xx=0.001;
I5yy=0.001;
I5zz=0.001;

I6xx=0.001;
I6yy=0.001;
I6zz=0.001;

 
a1=0.3;
a2=1;
a3=0.1;
d1=1;

d4=1;
d6=.5;

% d61=d6/2;
% d62=d6/2;

r1=1/2*d1;
r2=1/2*a2;
r3=3/4*d4;
r4=1/4*d4;
r5=1/4*d6;
r6=3/4*d6;

%the referece end effector possition is:

t=0;
t0=0;
starterror=0.05;


q=[
10*radref*sin(w1*t);    
radref*cos(w2*t);    
radref*sin(w3*t);    
radref*cos(w4*t);    
radref*sin(w5*t);    
radref*cos(w6*t);    
];

q=[0;0.1;-pi/2;0.2;0.3;0.4];

qd=turn_on_speed*[
10*w1*radref*cos(w1*t);    
-w2*radref*sin(w2*t);    
w3*radref*cos(w3*t);    
-w4*radref*sin(w4*t);    
w5*radref*cos(w5*t);    
-w6*radref*sin(w6*t);    
];

START=rand(6,1)*10*0;

ttt=[6.6598
    6.3221
    1.7038
    5.8833
    4.5390
    1.6812];
state=[ttt;zeros(6,1)];
state2=[[0.1;-pi/3;pi/3;0;pi/2;0.4];zeros(6,1)];
%state2=[[0.1;pi/3;-pi/3;0;-pi/2;0.4];zeros(6,1)];

%state2=[rand(6,1)*pi;zeros(6,1)];
Energy=[];
Kin=[];
Pot=[];
normC=[];
Jac=[];
RPY=[];
dRPY=[];

Bs=[];
dBs=[];


%ode45
%op=odeset('abstol',1e-7,'reltol',1e-7);
%[t,y]=ode45(@Robot,[0,10],[zeros(6,1);zeros(6,1)],op);


robot_handle=plot3(1,1,1,'-o','LineWidth',2);
hold on
robot_handle2=plot3(1,1,1,'-ok','LineWidth',2);
 ref_handle1=plot3(1,1,1,'-ro','LineWidth',1);
% ref_handle2=plot3(1,1,1,'-r','LineWidth',1);
% ref_handle3=plot3(1,1,1,'-r','LineWidth',1);
% ref_handle4=plot3(1,1,1,'-r','LineWidth',1);
% ref_handle5=plot3(1,1,1,'-r','LineWidth',1);
% ref_handle6=plot3(1,1,1,'-r','LineWidth',1);
% ref_handle7=plot3(1,1,1,'-r','LineWidth',1);
% ref_handle8=plot3(1,1,1,'-r','LineWidth',1);

dist_handle1=plot3(1,1,1,'black','LineWidth',1);
dist_handle2=plot3(1,1,1,'black','LineWidth',1);
dist_handle3=plot3(1,1,1,'black','LineWidth',1);
dist_handle4=plot3(1,1,1,'black','LineWidth',1);


ref_pos_handle=plot3(0,2,0,'g-','LineWidth',2);
pos_handle=plot3(0,2,0,'black-','LineWidth',2);
set(ref_pos_handle,'Xdata',[],'Ydata',[],'Zdata',[])
set(pos_handle,'Xdata',[],'Ydata',[],'Zdata',[])

%refs=[ref_handle1;ref_handle2;ref_handle3;ref_handle4;ref_handle5;ref_handle6;ref_handle7;ref_handle8;];

h=0.005;
time=.2;

q_save=[];
qd_save=[];
o6_save=[];
o6d_save=[];
o6d=1;

dets=[];

pos_error=[];
orientation_error=[];
orientation_error_proj=[];

q_error=[];
qd_error=[];
vels=[];

W=[];
Wt=[];
Wtt=[];

U=[];

rpy=[];
rpyd=[];

PL1=[];
PL2=[];
PL3=[];
PL4=[];
plott=[];

time=[];

if turn_on_speed==0
     global_time=t;
end
% 

r_sphere=0.8;
pc=[1.2;1.2;1];

% pc1=1;
% pc2=1;
% pc3=sin(0.2*t)+0.5;

[x_s y_s z_s]=sphere(30);
%sphere_handle=surf((x_s*r_sphere+pc(1)),(y_s*r_sphere+pc(2)),(z_s*r_sphere+pc(3)));

plot3([-2 2 2 -2 -2],[-2 -2 2 2 -2],[0 0 0 0 0],'black','linewidth',2)
%set(sphere_handle,'FaceAlpha',0)
axis([-3 3 -3 3 0 4])
axis square
grid on


pc33=1;
pc11=2*cos(t*w_ball);
pc22=2*sin(t*w_ball);
pc2=[pc11;pc22;pc33];
%sphere_handle2=surf((x_s*r_sphere+pc2(1)),(y_s*r_sphere+pc2(2)),(z_s*r_sphere+pc2(3)));
%set(sphere_handle2,'FaceAlpha',0)

lengz=1000000;
regf=1;
if do_ode45==1
    op=odeset('reltol',1e-5,'abstol',1e-5);
    [time,y]=ode45(@Robot3,[1.5 5],[q;qd],op);
    lengz=length(time);
    regf=20;
end


%%
time_ode=t0;
h_ode=0.001;
for cnt=1:lengz

% time=[time t];
if do_ode45==1
    time_ode=time_ode+h_ode;
    [val ind]=min(abs(time-time_ode));
    t=time(ind);
    state=y(ind,:)';
    
    if ind==length(time)
        break
    end
    
else

    if turn_on_speed==1
        %Leader
        k1=Robot3(t,state);
        k2=Robot3(t+1/2*h,state+h/2*k1);
        k3=Robot3(t+1/2*h,state+h/2*k2);
        k4=Robot3(t+h,state+h*k3);
        state=state+1/6*h*(k1+2*k2+2*k3+k4);

        qdd=1/6*(k1(7:12)+2*k2(7:12)+2*k3(7:12)+k4(7:12));
        
%         PL1=[PL1 state(1:6)];
%         PL2=[PL2 state(7:12)];
%         PL3=[PL3 qdd];
%         PL4=[PL4 k1(7:12)];

        %follower
        qref=[state;qdd];
        k1=Robot5(t,state2,qref);
        k2=Robot5(t+1/2*h,state2+h/2*k1,qref);
        k3=Robot5(t+1/2*h,state2+h/2*k2,qref);
        k4=Robot5(t+h,state2+h*k3,qref);
        state2=state2+1/6*h*(k1+2*k2+2*k3+k4);

        t=t+h;
    else

        k1=Robot3(t,state);
        k2=Robot3(t,state+h/2*k1);
        k3=Robot3(t,state+h/2*k2);
        k4=Robot3(t,state+h*k3);
        state=state+1/6*h*(k1+2*k2+2*k3+k4);

    end

end

if turn_on_speed==0
     t=global_time;
end

t
if do_ode45==1 || (do_ode45==0 && mod(cnt,5)==0)

time=[time t];
%pc3=cos(w_ball*t)+0.5;    
%set(sphere_handle,'Zdata',(z_s*r_sphere+pc3))
    

pc33=1;
pc11=2*cos(t*w_ball);
pc22=2*sin(t*w_ball);
pc2=[pc11;pc22;pc33];

%set(sphere_handle2,'Xdata',(x_s*r_sphere+pc2(1)),'Ydata',(y_s*r_sphere+pc2(2)));
    
    
    
qr=[
w1*t;    
radref*sin(w2*t);    
radref*sin(w3*t);    
radref*cos(w4*t);    
radref*sin(w5*t);    
radref*cos(w6*t);    
];
qr=qr+START;
qrd=turn_on_speed*[
w1;    
-w2*radref*cos(w2*t);    
-w3*radref*cos(w3*t);    
-w4*radref*sin(w4*t);    
w5*radref*cos(w5*t);    
-w6*radref*sin(w6*t);    
];
qrdd=turn_on_speed*[
0;    
-w2^2*radref*sin(w2*t);    
-w3^2*radref*sin(w3*t);    
-w4^2*radref*cos(w4*t);    
-w5^2*radref*sin(w5*t);    
-w6^2*radref*cos(w6*t);    
];

q1=state(1);
q2=state(2);
q3=state(3);
q4=state(4);
q5=state(5);
q6=state(6);

q=state(1:6);
qd=state(7:12);
                 
T=forward_kinematics(q);
J=jacobian_end_effector(q);
Rq=T(1:3,1:3);

Tr=forward_kinematics(qr);
Rr=Tr(1:3,1:3);


%W=[W [phi;theta;psi]];
% 
% B=[0 -sin(phi) cos(phi)*cos(theta);
%        0 cos(phi) sin(phi)*cos(theta);
%        1          0        -sin(theta)];
% 
%    
% 
% qd_save=[qd_save T(1:3,4)];
% U=[U Ut];
dets=[dets det(J)];
% 
% u_repulsive=zeros(3,1);
% x=T(1:3,4);
% rho_0=0.5;
% 
% v=J*qd;


Rdiff=Tr(1:3,1:3);
psi = atan2(Rdiff(3,2),Rdiff(3,3));
phi = atan2(Rdiff(2,1),Rdiff(1,1));
theta = atan2(-Rdiff(3,1),cos(phi)*Rdiff(1,1) + sin(phi)*Rdiff(2,1));

ref_ori=[ref_ori [phi;theta;psi]];

Rdiff=T(1:3,1:3);
psi = atan2(Rdiff(3,2),Rdiff(3,3));
phi = atan2(Rdiff(2,1),Rdiff(1,1));
theta = atan2(-Rdiff(3,1),cos(phi)*Rdiff(1,1) + sin(phi)*Rdiff(2,1));

leader_ori=[leader_ori [phi;theta;psi]];

Tfol=forward_kinematics(state2(1:6));
Rdiff=Tfol(1:3,1:3);
psi = atan2(Rdiff(3,2),Rdiff(3,3));
phi = atan2(Rdiff(2,1),Rdiff(1,1));
theta = atan2(-Rdiff(3,1),cos(phi)*Rdiff(1,1) + sin(phi)*Rdiff(2,1));

follower_ori=[follower_ori [phi;theta;psi]];




Rdiff=Tfol(1:3,1:3)'*T(1:3,1:3);
psi = atan2(Rdiff(3,2),Rdiff(3,3));
phi = atan2(Rdiff(2,1),Rdiff(1,1));
theta = atan2(-Rdiff(3,1),cos(phi)*Rdiff(1,1) + sin(phi)*Rdiff(2,1));

ori_error=[ori_error [phi;theta;psi]];
pos_error=[pos_error Tfol(1:3,4)-T(1:3,4)];

%find the normal vector

err=Tfol(1:3,4)-T(1:3,4);
rho_0=0.6;
x=Tfol(1:3,4);
%first wall
if abs(x(2)+2)<rho_0 %&& v(2)<0
     n=[0;1;0];
     err=err-err'*n*n;
end

%second wall
if abs(x(2)-2)<rho_0 %&& v(2)>0
     n=[0;-1;0];
     err=err-err'*n*n;
end

%third  wall
if abs(x(1)+2)<rho_0 %&& v(1)<0    
     n=[1;0;0];
     err=err-err'*n*n;

end

%fourth wall
if abs(x(1)-2)<rho_0 %&& v(1)>0
     n=[-1;0;0];
     err=err-err'*n*n;

end

%floor end effector force
if abs(x(3))<rho_0 %&& v(3)<0
     n=[0;0;1];
     err=err-err'*n*n;

end
% 
% if Globn(1)~=0 && Globn(2)~=0 && Globn(3)~=0
%      err=err-err'*Globn*Globn;
% end    

orientation_error_proj=[orientation_error_proj err];


%---------------------End Simulation--------------------------
%---------------------Start PLotting--------------------------
o0 =[
    0
    0
    0];


o1 =[
 a1*sin(q1)
 a1*cos(q1)
         d1];
 
 
o2 =[
 sin(q1)*(a1 + a2*cos(q2))
 cos(q1)*(a1 + a2*cos(q2))
               d1 - a2*sin(q2)];
 
 
o3 =[
 sin(q1)*(a1 + a2*cos(q2) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2)];
 
 
o4 =[
 sin(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
 
 
o5 =[
 sin(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
 
 
o6 =[
 sin(q1).*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3)) + d6*(sin(q5).*(cos(q1)*sin(q4) - cos(q4)*sin(q2+q3)*sin(q1)) + cos(q2+q3)*cos(q5)*sin(q1))
 cos(q1).*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3)) - d6*(sin(q5).*(sin(q1)*sin(q4) + cos(q1)*cos(q4)*sin(q2+q3)) - cos(q2+q3)*cos(q1)*cos(q5))
                                                                   d1 - d6*(cos(q5)*sin(q2+q3) + cos(q2+q3)*cos(q4)*sin(q5)) - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
            


% jointpos=[o0 o1 o2 o3 o4 o5 o6];

jointpos=[o5 o6];

plot3(o6(1),o6(2),o6(3),'x');
set(robot_handle,'Xdata',jointpos(1,:),'Ydata',jointpos(2,:),'Zdata',jointpos(3,:))



%save for the plots

T_ref=forward_kinematics(qr);

ref_pos=[ref_pos T_ref(1:3,4)];
leader_pos=[leader_pos o6];



%end saving





q1=state2(1);
q2=state2(2);
q3=state2(3);
q4=state2(4);
q5=state2(5);
q6=state2(6);
q=state2(1:6);
qd=state2(7:12);

o0 =[
    0
    0
    0];


o1 =[
 a1*sin(q1)
 a1*cos(q1)
         d1];
 
 
o2 =[
 sin(q1)*(a1 + a2*cos(q2))
 cos(q1)*(a1 + a2*cos(q2))
               d1 - a2*sin(q2)];
 
 
o3 =[
 sin(q1)*(a1 + a2*cos(q2) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2)];
 
 
o4 =[
 sin(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
 
 
o5 =[
 sin(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
 
 
o6 =[
 sin(q1).*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3)) + d6*(sin(q5).*(cos(q1)*sin(q4) - cos(q4)*sin(q2+q3)*sin(q1)) + cos(q2+q3)*cos(q5)*sin(q1))
 cos(q1).*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3)) - d6*(sin(q5).*(sin(q1)*sin(q4) + cos(q1)*cos(q4)*sin(q2+q3)) - cos(q2+q3)*cos(q1)*cos(q5))
                                                                   d1 - d6*(cos(q5)*sin(q2+q3) + cos(q2+q3)*cos(q4)*sin(q5)) - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
            


                                                               
x=Tfol(1:3,4);
min_dist=min([abs(x(2)+2),abs(x(2)-2),abs(x(1)+2),abs(x(1)-2),abs(x(3)),o2(3),o3(3),o4(3),o5(3)]);

shortest_distance=[shortest_distance min_dist];
input=[input U_save];
follower_pos=[follower_pos o6];
                                                               
jointpos=[o0 o1 o2 o3 o4 o5 o6];

plot3(o6(1),o6(2),o6(3),'kx');
set(robot_handle2,'Xdata',jointpos(1,:),'Ydata',jointpos(2,:),'Zdata',jointpos(3,:))

% 
% if mod(cnt,100)==1
% sphere_handle3=surf((x_s*r_sphere+pc(1)),(y_s*r_sphere+pc(2)),(z_s*r_sphere+pc(3)));
% 
% robot_handle11=plot3(1,1,1,'-og','LineWidth',2);
% set(robot_handle11,'Xdata',jointpos(1,:),'Ydata',jointpos(2,:),'Zdata',jointpos(3,:))
% % set(robot_handle21,'Xdata',jointpos(1,:),'Ydata',jointpos(2,:),'Zdata',jointpos(3,:))
%  set(sphere_handle3,'FaceAlpha',0)
% 
% end

Bs=[Bs SAVE_B];
dBs=[dBs SAVE_Bd];


T_ref=forward_kinematics(qr);
% q_ref=invKin3(T_ref,[]);
% 
% for vg=1:8
% ref_h=refs(vg);
% set(ref_h,'Xdata',1,'Ydata',1,'Zdata',1)
% end
% 
% for vg=1:size(q_ref,2)
q_temp=qr;
q1=q_temp(1);
q2=q_temp(2);
q3=q_temp(3);
q4=q_temp(4);
q5=q_temp(5);
q6=q_temp(6);

o0 =[
    0
    0
    0];
o1 =[
 a1*sin(q1)
 a1*cos(q1)
         d1];
o2 =[
 sin(q1)*(a1 + a2*cos(q2))
 cos(q1)*(a1 + a2*cos(q2))
               d1 - a2*sin(q2)];
o3 =[
 sin(q1)*(a1 + a2*cos(q2) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2)];
o4 =[
 sin(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
o5 =[
 sin(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)]; 
o6 =[
 sin(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3)) + d6*(sin(q5)*(cos(q1)*sin(q4) - cos(q4)*sin(q2+q3)*sin(q1)) + cos(q2+q3)*cos(q5)*sin(q1))
 cos(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3)) - d6*(sin(q5)*(sin(q1)*sin(q4) + cos(q1)*cos(q4)*sin(q2+q3)) - cos(q2+q3)*cos(q1)*cos(q5))
                                                                   d1 - d6*(cos(q5)*sin(q2+q3) + cos(q2+q3)*cos(q4)*sin(q5)) - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
                                                              

                                                               
jointpos=[o5 o6];
% 
% ref_h=refs(vg);
set(ref_handle1,'Xdata',jointpos(1,:),'Ydata',jointpos(2,:),'Zdata',jointpos(3,:))

 %plot3(o6(1),o6(2),o6(3),'rx');


%end
% % 
% plot3(o6(1),o6(2),o6(3),'rx')

%
% x_ref =[radref*sin(t);radref*cos(t);sin(t)];
% set(ref_handle1,'Xdata',x_ref(1),'Ydata',x_ref(2),'Zdata',x_ref(3))
% 


%do more plotting 



drawnow

if record==1
    F = getframe(fig);
    aviobj = addframe(aviobj,F);
end

if t>10
    11
    break
end

end

%---------------------End PLotting--------------------------

% % 
% q_save=[q_save o6r-o6];
% 
% 
% T=forward_kinematics(q);
% Rq=T(1:3,1:3);
% Tr=forward_kinematics(qr);
% Rr=Tr(1:3,1:3);
% oe=1/2*(cross(Rq(:,1),Rr(:,1))+cross(Rq(:,2),Rr(:,2))+cross(Rq(:,3),Rr(:,3)));
% 
% qd_save=[qd_save oe];

% o6_save=[o6_save a_ref];


% %J2=J(1:3,1:6);
% o6d_save=[o6d_save J*qd-J*qrd];
                 
end


if record==1
    close(fig)
    aviobj = close(aviobj);
end
break
% ref_pos=[];
% leader_pos=[];
% follower_pos=[];
% ref_ori=[];
% leader_ori=[];
% follower_ori=[];
% pos_error=[];
% ori_error=[];
% shortest_distance=[];
% input=[];
%%
subplot(3,2,1)
%position
title('Position','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
axis square
hold on
grid on
plot(time,ref_pos(2,:),'r','linewidth',1.5)
plot(time,leader_pos(2,:),'g','linewidth',1.5)
plot(time,follower_pos(2,:),'linewidth',1.5)
xlim([0 t])
leg=legend('Reference','Leader','Follower');
set(leg,'interpreter','Latex')

subplot(3,2,2)
%orientation
title('Orientation','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
axis square
hold on
grid on
plot(time,ref_ori(2,:),'r','linewidth',1.5)
plot(time,leader_ori(2,:),'g','linewidth',1.5)
plot(time,follower_ori(2,:),'linewidth',1.5)
xlim([0 t])
ylim([-pi pi])
leg=legend('Reference','Leader','Follower');
set(leg,'interpreter','Latex')

subplot(3,2,3)
%position error 
title('Position error','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
hold on
grid on
axis square
plot(time,pos_error','linewidth',1.5)
xlim([0 t])

subplot(3,2,4)
%orientation erro
title('Orientation error','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
hold on
grid on
axis square
plot(time,ori_error','linewidth',1.5)
xlim([0 t])

subplot(3,2,5)
%shortest distance
title('Collision distance','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
hold on
grid on
axis square
plot(time,shortest_distance,'linewidth',1.5)
xlim([0 t])

subplot(3,2,6)
%input
title('Control input','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
hold on
grid on
axis square
plot(time,input','linewidth',1.5)
xlim([0 t])
ylim([-15000 15000])
     


%%
subplot(3,2,1)
%position
title('Position','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
axis square
hold on
grid on
plot(time,ref_pos(1,:),'r','linewidth',1.5)
plot(time,leader_pos(1,:),'g','linewidth',1.5)
plot(time,follower_pos(1,:),'linewidth',1.5)
xlim([0 t])
leg=legend('Reference','Leader','Follower');
set(leg,'interpreter','Latex')


subplot(3,2,2)
%orientation
title('Orientation','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
axis square
hold on
grid on
plot(time,ref_ori(1,:),'r','linewidth',1.5)
plot(time,leader_ori(1,:),'g','linewidth',1.5)
plot(time,follower_ori(1,:),'linewidth',1.5)
xlim([0 t])
ylim([-pi pi])
leg=legend('Reference','Leader','Follower');
set(leg,'interpreter','Latex')

subplot(3,2,3)
%position error 
title('Position error','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
hold on
grid on
axis square
plot(time,pos_error','linewidth',1.5)
xlim([0 t])

subplot(3,2,4)
%orientation erro
title('Orientation error','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
hold on
grid on
axis square
plot(time,ori_error','linewidth',1.5)
xlim([0 t])

subplot(3,2,5)
%shortest distance
title('$det(J(t))$','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
hold on
grid on
axis square
plot(time,dets,'linewidth',1.5)
xlim([0 t])

subplot(3,2,6)
%input
title('Control input','interpreter','Latex','FontSize',12)
xlabel('time [s]','interpreter','Latex','FontSize',12)
hold on
grid on
axis square
plot(time,input','linewidth',1.5)
xlim([0 t])
ylim([-500 500])









































